#ifndef __HITECK_GAME_H
#define __HITECK_GAME_H

#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include <string.h>

#include "vt.h"

#define GRIDXSIZE 10
#define GRIDYSIZE 10
#define BLANKCHAR '.'

char grid[GRIDXSIZE][GRIDYSIZE];

#define PLAYER1 'X'
#define PLAYER2 'O'

extern char *keyset;
extern int mark_x, mark_y, sx, sy;
extern int p1_count, p2_count;

void grid_render(char mark);
void draw_text(int x, int y, char *text);
void grid_draw_mark(int x, int y);
void grid_draw_inverse_mark(int x, int y);
void grid_draw_blinking_mark(int x, int y);
char check_for_mark(int x, int y, char mark);
char check_for_win();
void grid_init();
void status(char *msg);
void process_move(int sx, int sy, int tx, int ty, char mark);
int is_possible_move(int mx, int my, int px, int py);
void show_possible_moves(int mx, int my);
int place_mark(char mark);
void update_state(void);
void grid_random_init(int pieces);
void print_status(char *local_name, char mark, char *remote_name);
int  player_can_move(char mark);

#endif
