#include "score.h"
#include "vt.h"

void format_time(int seconds, char *buffer)
{
	sprintf(buffer, "%2d min %2d s", seconds/60, seconds%60);
}

void update_userdata(char *userfile, char *user, int score, int time)
{
	FILE *handle = fopen(userfile, "r+");
		
	int found=0;
	long offset=0;

	user_data u;
	memset(&u, 0, sizeof(user_data));

	if (handle==NULL)
	{
		handle = fopen(userfile, "w+");
		fclose(handle);
		handle = fopen(userfile, "r+");
	}

        if (handle==NULL)
        {
                fprintf(stderr, "Unable to update data file.\n\r");
                return;
        }

	while (!feof(handle))
	{
		offset = ftell(handle);
		fread(&u, sizeof(user_data), 1, handle);
		if (strcmp(u.name, user)==0)
		{
			found=1;
			break;
		}
	}
	if (!found)
	{
		fseek(handle, 0, SEEK_END);
		offset = ftell(handle);
		memset(&u, 0, sizeof(user_data));
		u.score = 0;
		u.time = 0;
	}

	fseek(handle, offset, SEEK_SET);
	strcpy(u.name, user);
	if (score > u.score)
	{
		u.score = score;
		u.time  = time;
	}
	u.games++;
	fwrite(&u, sizeof(user_data), 1, handle);	
	
	fclose(handle);
}

void view_top(char *userfile, int num)
{
        FILE *handle = fopen(userfile, "r");

	char buffer[16];
        int i=0, j, k;
        long high=0;

        user_data *u = (user_data*)malloc(MAX_USERS*sizeof(user_data));
        memset(u, 0, sizeof(user_data)*MAX_USERS);

        if (handle == NULL)
        {
                fprintf(stderr, "Unable to open data file.\n\r");
                return;
        }

	
	for (;;)
        {
                fread(&u[i], sizeof(user_data), 1, handle);
		if (feof(handle)) break;
		if (u[i].score > high) high=u[i].score;
		i++;
	}
	k = 1;

	for (;high>=0; high--)
	for (j=0; j<i; j++)
		if (u[j].score==high)
		{
			if (k==1) printf(VT_BOLD);
			format_time(u[j].time, buffer);
			printf(LISTFORMAT,
				k++, u[j].name, u[j].score, buffer, u[j].games);
			if (k==num+1) break;
			if (k==2) printf(VT_NORMAL);
		}

	free(u);
	fclose(handle);
}
